package com.example.nto.service.impl;

import com.example.nto.entity.Employee;
import com.example.nto.repository.CodeRepository; // Импортируйте нужный репозиторий
import com.example.nto.repository.EmployeeRepository;
import com.example.nto.service.EmployeeService;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;

@Service
public class EmployeeServiceImpl implements EmployeeService {

    private final EmployeeRepository employeeRepository;
    private final CodeRepository codeRepository; // Добавьте CodeRepository как зависимость

    // Конструктор с внедрением
    public EmployeeServiceImpl(EmployeeRepository employeeRepository, CodeRepository codeRepository) {
        this.employeeRepository = employeeRepository;
        this.codeRepository = codeRepository; // Инициируем код репозиторий
    }

    @Override
    public List<Employee> findAll() {
        return employeeRepository.findAll();
    }

    @Override
    public Optional<Employee> findByLogin(String login) {
        return Optional.ofNullable(employeeRepository.findByLogin(login));
    }

    @Override
    public boolean validateCode(String login, long code) {
        // Получаем все коды для данного логина
        List<Long> validCodes = codeRepository.findCodesByLogin(login); // Теперь вызывается из объекта

        // Проверяем, если переданный код присутствует в списке
        boolean isValid = validCodes.contains(code);

        // Вывод отладочной информации
        System.out.println("Valid codes: " + validCodes);
        System.out.println("Input code: " + code);

        return isValid;
    }
}